# print_color_strings.s

# Syscalls
.equ SYSCALL_EXIT,     1
.equ SYSCALL_WRITE,    4

# Other definitions
.equ STDOUT,	       1

        .globl _start
_start:

	mov	r0,#0		@ Clear r0 to 0

loop:

	/* Your code here */

	ldr	r1,=your_string
	bl	print_string

	/* Possibly some code here */

	add	r0,r0,#1
	cmp	r0,#8
	bne	loop

        #================================
        # Exit
        #================================
exit:
	mov	r0,#5
        mov     r7,$SYSCALL_EXIT	@ put exit syscall number (1) in r7
        swi	0x0			@ and exit


	@====================
	@ print string
	@====================
	@ Null-terminated string to print pointed to by r1
	@ r1 is trashed by this routine

print_string:

        push    {r0,r2,r7,r10,lr}       @ Save r0,r2,r3,lr on stack

        mov     r2,r1                   @ copy string pointer

count_loop:
        ldrb    r10,[r2],#1             @ load byte from address r1+r2
        cmp     r10,#0                  @ Compare against 0
        bne     count_loop              @ if not 0, loop

        sub     r2,r2,r1                @ subtract to get size
	sub	r2,r2,#1		@ adjust because we counted the NUL terminator

        mov     r0,#STDOUT              @ Print to stdout
        mov     r7,#SYSCALL_WRITE       @ Load syscall number
        swi     0x0                     @ System call

        pop     {r0,r2,r7,r10,pc}       @ pop r0,r2,r3,pc from stack



        ##############################
	# print_number
	##############################
	# r0 = value to print

print_number:
	stmfd	SP!,{r10,LR}            @ store return address on stack
        ldr	r10,=buffer
        add	r10,r10,#10		@ point to end of our buffer

divide:
        bl      divide_by_10    @ Q=r7,$0, R=r8,$1
        add     r8,r8,#0x30     @ convert to ascii
        strb    r8,[r10],#-1    @ store a byte, decrement pointer
        adds    r0,r7,#0        @ move Q in for next divide, update flags
        bne     divide		@ if Q not zero, loop

write_out:
        add     r1,r10,#1       @ adjust pointer

        bl	print_string	@ else, fallthrough to stdout

        ldmfd   SP!,{r10,LR}    @ restore return address from stack

        bx	lr

	##############################
	# divde_by_10
	##############################
	# r0=numerator
        # r4,r5 trashed
	# r7 = quotient, r8 = remainder
divide_by_10:
	ldr     r4,=429496730		@ 1/10 * 2^32
	sub     r5,r0,r0,lsr #30
	umull   r8,r7,r4,r5		@ {r8,r7}=r4*r5

	mov	r4,#10			@ calculate remainder
	mul	r8,r7,r4
	sub	r8,r0,r8

	bx	lr

.data
your_string:	.string "Hello!\n"

.lcomm buffer,11
